#version 300 es

// SDL created ES context requires this on Linux.
#extension GL_OES_standard_derivatives : enable

// Calculated as 1.0 / (far - near)
uniform highp float uLinearDepthConstant;

in highp vec4 vPosition;

out lowp vec4 fragColor;

void main()
{
    highp float linearDepth = gl_FragCoord.z;
    
    highp float dx = dFdx( linearDepth );
    highp float dy = dFdy( linearDepth );
    
    highp float moment1 = linearDepth;
    highp float moment2 = linearDepth * linearDepth + 0.25 * (dx * dx + dy * dy);
    
    fragColor = vec4( moment1, moment2, 0.0, 1.0 );
}

