#version 150 core

uniform sampler2D textureMap;

in vec2 vTexCoord;

out vec4 fragColor;

void main()
{
    vec2 texelSize = 1.0 / vec2( textureSize( textureMap, 0 ) );
	
    fragColor = vec4( 0.0 );
    const int uBlurSize = 4; // Should equal to noise texture size.
    vec2 hlim = vec2( float(-uBlurSize) * 0.5 + 0.5 );
    
    for (int x = 0; x < uBlurSize; ++x)
    {
        for (int y = 0; y < uBlurSize; ++y)
        {
            vec2 offset = vec2( float( x ), float( y ) );
            offset += hlim;
            offset *= texelSize;
            
            fragColor += texture( textureMap, vTexCoord + offset );
        }
    }
	
    fragColor = fragColor / (uBlurSize * uBlurSize);
}

