cbuffer buffer : register(b0)
{
    column_major matrix modelViewProjection;
}

struct VS_INPUT
{
    float3 Pos : POSITION;
};

struct PS_INPUT
{
    float4 position : SV_POSITION;
    float3 texCoord : TEXCOORD0;
};

PS_INPUT VS( VS_INPUT input )
{
    PS_INPUT output = (PS_INPUT)0;
    output.position = mul( modelViewProjection, float4( input.Pos, 1 ) );
    output.texCoord = input.Pos;
    return output;
}

TextureCube textureMap : register(t0);
SamplerState SampleType : register(s0);

float4 PS( PS_INPUT input ) : SV_Target
{
    return textureMap.Sample( SampleType, input.texCoord );
}
