#ifndef ERRORS_H
#define ERRORS_H

namespace Error
{
    /// Error enumerations.
    enum Enum
    {
        NO_ERRORS = 0,
        DLL_NOT_FOUND,
        UNSUPPORTED_RENDERER, // GPU driver does not support requested renderer.
        FACTORY_NOT_FOUND,    // Create*() is missing/not exported from DLL.
        DLL_VERSION_MISMATCH, // Include folder headers's version does not match those used to compile DLL.
        CONTRACT_VIOLATION,   // Method does not do what it is meant to do.
        SHADER_NOT_FOUND,     // Shader source file not found.
        VERTEX_SHADER_COMPILE_FAILED, // Shader compile failed.
        FRAGMENT_SHADER_COMPILE_FAILED, // Shader compile failed.
        GEOMETRY_SHADER_COMPILE_FAILED, // Shader compile failed.
        SHADER_LINK_FAILED,   // Linking failed.
        FILE_NOT_FOUND,       // File not found.
        CORRUPTED_DATA,       // Corrupted data.
        OUT_OF_MEMORY,        // Out of memory.
        TOO_MANY_JOINTS,        // Too many joints.
        COMPUTE_SHADER_COMPILE_FAILED, // Compile shader compile failed.
        GENERIC,
        count
    };
}

#endif
