#ifndef KEYBOARD_INPUT_H
#define KEYBOARD_INPUT_H

namespace ae3d
{
    namespace keyboardinput
    {
        /// Key names.
        enum Enum
        {
            KEY_ESC = 0,
            KEY_a,
            KEY_b,
            KEY_c,
            KEY_d,
            KEY_e,
            KEY_f,
            KEY_g,
            KEY_h,
            KEY_i,
            KEY_j,
            KEY_k,
            KEY_l,
            KEY_m,
            KEY_n,
            KEY_o,
            KEY_p,
            KEY_q,
            KEY_r,
            KEY_s,
            KEY_t,
            KEY_u,
            KEY_v,
            KEY_w,
            KEY_x,
            KEY_y,
            KEY_z,
            KEY_UP,
            KEY_DOWN,
            KEY_LEFT,
            KEY_RIGHT,
            count
        };
    }
}

/// Reads keyboard.
class KeyboardInput
{
  public:
    /// Destructor.
    virtual ~KeyboardInput() {}

    /**
       Tests the key state.

       \param key Key to be tested.
       \return True if the key is down, false otherwise.
     */
    virtual bool IsDown( ae3d::keyboardinput::Enum key ) const = 0;
};

#endif
