#ifndef FILEWATCHER_H
#define FILEWATCHER_H

#ifndef INCLUDE_MEMORY_H
#    include <memory>
#    define INCLUDE_MEMORY_H
#endif

/**
   Watches resource files for changes and reloads them.
 
   \fixme Seems to load files while they're being written into, so can get corrupt data.
 */
class FileWatcher
{
  public:
    static FileWatcher& Instance();
    FileWatcher( const FileWatcher& ) = delete;
    FileWatcher& operator=( const FileWatcher& ) = delete;
    void AddAudioClip( const char* path );
    void AddModel( const char* path );
    void AddTexture( const char* path );
    void AddShader( const char* vertexPath, const char* fragmentPath, const char* geometryPath, const char* defines );
    /// Should be called at reasonable interval, eg. 1 second.
    void Poll();

  private:
    FileWatcher();
    ~FileWatcher();

    struct Impl;
    std::unique_ptr< Impl > m;
};
#endif
