#include "KeyboardInputSDL.hpp"
// for memcpy inside SDL
#include <string.h>
#include <SDL/SDL.h>

#ifdef AETHER3D_WINDOWS
#    define AETHER3D_API __declspec(dllexport)
#else
#    define AETHER3D_API
#endif

extern "C" AETHER3D_API KeyboardInput* CreateKeyboardInput()
{
    return new KeyboardInputSDL();
}

KeyboardInputSDL::KeyboardInputSDL()
{
    mKeys[ ae3d::keyboardinput::KEY_ESC   ] = SDL_SCANCODE_ESCAPE;
    mKeys[ ae3d::keyboardinput::KEY_UP    ] = SDL_SCANCODE_UP;
    mKeys[ ae3d::keyboardinput::KEY_DOWN  ] = SDL_SCANCODE_DOWN;
    mKeys[ ae3d::keyboardinput::KEY_LEFT  ] = SDL_SCANCODE_LEFT;
    mKeys[ ae3d::keyboardinput::KEY_RIGHT ] = SDL_SCANCODE_RIGHT;
    mKeys[ ae3d::keyboardinput::KEY_a ] = SDL_SCANCODE_A;
    mKeys[ ae3d::keyboardinput::KEY_b ] = SDL_SCANCODE_B;
    mKeys[ ae3d::keyboardinput::KEY_c ] = SDL_SCANCODE_C;
    mKeys[ ae3d::keyboardinput::KEY_d ] = SDL_SCANCODE_D;
    mKeys[ ae3d::keyboardinput::KEY_e ] = SDL_SCANCODE_E;
    mKeys[ ae3d::keyboardinput::KEY_f ] = SDL_SCANCODE_F;
    mKeys[ ae3d::keyboardinput::KEY_g ] = SDL_SCANCODE_G;
    mKeys[ ae3d::keyboardinput::KEY_h ] = SDL_SCANCODE_H;
    mKeys[ ae3d::keyboardinput::KEY_i ] = SDL_SCANCODE_I;
    mKeys[ ae3d::keyboardinput::KEY_j ] = SDL_SCANCODE_J;
    mKeys[ ae3d::keyboardinput::KEY_k ] = SDL_SCANCODE_K;
    mKeys[ ae3d::keyboardinput::KEY_l ] = SDL_SCANCODE_L;
    mKeys[ ae3d::keyboardinput::KEY_m ] = SDL_SCANCODE_M;
    mKeys[ ae3d::keyboardinput::KEY_n ] = SDL_SCANCODE_N;
    mKeys[ ae3d::keyboardinput::KEY_o ] = SDL_SCANCODE_O;
    mKeys[ ae3d::keyboardinput::KEY_p ] = SDL_SCANCODE_P;
    mKeys[ ae3d::keyboardinput::KEY_q ] = SDL_SCANCODE_Q;
    mKeys[ ae3d::keyboardinput::KEY_r ] = SDL_SCANCODE_R;
    mKeys[ ae3d::keyboardinput::KEY_s ] = SDL_SCANCODE_S;
    mKeys[ ae3d::keyboardinput::KEY_t ] = SDL_SCANCODE_T;
    mKeys[ ae3d::keyboardinput::KEY_u ] = SDL_SCANCODE_U;
    mKeys[ ae3d::keyboardinput::KEY_v ] = SDL_SCANCODE_V;
    mKeys[ ae3d::keyboardinput::KEY_w ] = SDL_SCANCODE_W;
    mKeys[ ae3d::keyboardinput::KEY_x ] = SDL_SCANCODE_X;
    mKeys[ ae3d::keyboardinput::KEY_y ] = SDL_SCANCODE_Y;
    mKeys[ ae3d::keyboardinput::KEY_z ] = SDL_SCANCODE_Z;
}

bool KeyboardInputSDL::IsDown( ae3d::keyboardinput::Enum key ) const
{
    const Uint8* state = SDL_GetKeyboardState( nullptr );    
    return state[ mKeys[ key ] ] == 1;
}
