#ifndef KEYBOARD_INPUT_WIN_H
#define KEYBOARD_INPUT_WIN_H
#ifdef AETHER3D_WINDOWS

#ifndef KEYBOARD_INPUT_H
#    include "KeyboardInput.hpp"
#endif

class KeyboardInputWin : public KeyboardInput
{
  public:
    /**
       Constructor, inits key codes.
     */
    KeyboardInputWin();
    virtual ~KeyboardInputWin() {}

    /**
       Reports key down state.
       \param key Key to be tested.
       \return True, if the key is down, false otherwise.
     */
    virtual bool IsDown( ae3d::keyboardinput::Enum key ) const;
    
    /// Windows message handler sets this in dllmain.cpp.
    static bool sKeyDown[ 256 ];

  private:
    int mKeys[ 256 ];
};

#endif
#endif
