#include "Statistics.hpp"

namespace Statistics
{
    int runningDrawCalls = 0;
    int drawCalls = 0;
    
    int runningRenderTargetSwitches = 0;
    int renderTargetSwitches = 0;
    
    int runningShaderSwitches = 0;
    int shaderSwitches = 0;
    
    int runningBufferSwitches = 0;
    int bufferSwitches = 0;

    int runningTextureSwitches = 0;
    int textureSwitches = 0;

    void EndFrame()
    {
        drawCalls = runningDrawCalls;
        runningDrawCalls = 0;
        
        renderTargetSwitches = runningRenderTargetSwitches;
        runningRenderTargetSwitches = 0;
        
        shaderSwitches = runningShaderSwitches;
        runningShaderSwitches = 0;
        
        bufferSwitches = runningBufferSwitches;
        runningBufferSwitches = 0;
        
        textureSwitches = runningTextureSwitches;
        runningTextureSwitches = 0;
    }

    void IncBufferSwitches()
    {
        ++runningBufferSwitches;
    }
    
    void IncDrawCalls()
    {
        ++runningDrawCalls;
    }
    
    void IncRenderTargetSwitches()
    {
        ++runningRenderTargetSwitches;
    }
    
    void IncTextureSwitches()
    {
        ++runningTextureSwitches;
    }
    
    void IncShaderSwitches()
    {
        ++runningShaderSwitches;
    }
    
    int BufferSwitches()
    {
        return bufferSwitches;
    }
    
    int DrawCalls()
    {
        return drawCalls;
    }
    
    int RenderTargetSwitches()
    {
        return renderTargetSwitches;
    }

    int ShaderSwitches()
    {
        return shaderSwitches;
    }

    int TextureSwitches()
    {
        return textureSwitches;
    }
}
