#include <iostream>
#include "Aether3D.hpp"

int main( int paramCount, char* params[] )
{
    Aether3D_API dll;
    Error::Enum error = dll.LoadDLL( paramCount > 1 ? std::string( params[ 1 ] ) : "" );

    if (error != Error::NO_ERRORS)
    {
        return (int)error;
    }

    Renderer* renderer = dll.MakeRenderer( "../../Assets/builtin/" );

    if (!renderer)
    {
        return (int)Error::FACTORY_NOT_FOUND;
    }

    int expectedWidth = 320;
    int expectedHeight = 200;
    error = renderer->OpenWindow( expectedWidth, expectedHeight, false, 1, true );

    if (error != Error::NO_ERRORS)
    {
        return (int)error;
    }

    return (renderer->Width() == expectedWidth &&
           renderer->Height() == expectedHeight) ?
           (int)Error::NO_ERRORS : (int)Error::CONTRACT_VIOLATION;
}

